<?php
/* Autor...:  */
/* Esquema.: SR_DevolucionTransaccion.xml */
/* Generado: 2021-05-13 05:56:55 */

/* Metodos de acceso a los campos de la tabla SR_DevolucionTransaccion */
abstract class BaseSR_DevolucionTransaccionBN
{
    /* Campos de la tabla */
    private $i_DevolucionTransId;    // DevolucionTransId: ( no definido )
    private $i_DevolucionCabId;    // DevolucionCabId: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdProyecto;    // IdProyecto: ( no definido )
    private $i_OrdenId;    // OrdenId: ( no definido )
    private $s_EstadoDevolucionId;    // EstadoDevolucionId: ( no definido )
    private $s_Tipo;    // Tipo: ( no definido )
    private $s_IdAlmacenOrigen;    // IdAlmacenOrigen: ( no definido )
    private $s_IdAlmacenDestino;    // IdAlmacenDestino: ( no definido )
    private $s_IdTipoDocumento;    // IdTipoDocumento: ( no definido )
    private $s_IdNumeroDocumento;    // IdNumeroDocumento: ( no definido )
    private $s_IdTransaccion;    // IdTransaccion: ( no definido )
    private $s_TipoDocumentoFiscal;    // TipoDocumentoFiscal: ( no definido )
    private $s_SerieDocumentoFiscal;    // SerieDocumentoFiscal: ( no definido )
    private $s_NumeroDocumentoFiscal;    // NumeroDocumentoFiscal: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )

    /* Establece el valor del campo DevolucionTransId */
    public function setDevolucionTransId( $i_DevolucionTransId )
    {
        $this->i_DevolucionTransId = $i_DevolucionTransId;
    }

    /* Obtiene el valor del campo DevolucionTransId */
    public function getDevolucionTransId()
    {
        return $this->i_DevolucionTransId;
    }

    /* Establece el valor del campo DevolucionCabId */
    public function setDevolucionCabId( $i_DevolucionCabId )
    {
        $this->i_DevolucionCabId = $i_DevolucionCabId;
    }

    /* Obtiene el valor del campo DevolucionCabId */
    public function getDevolucionCabId()
    {
        return $this->i_DevolucionCabId;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdProyecto */
    public function setIdProyecto( $i_IdProyecto )
    {
        $this->i_IdProyecto = $i_IdProyecto;
    }

    /* Obtiene el valor del campo IdProyecto */
    public function getIdProyecto()
    {
        return $this->i_IdProyecto;
    }

    /* Establece el valor del campo OrdenId */
    public function setOrdenId( $i_OrdenId )
    {
        $this->i_OrdenId = $i_OrdenId;
    }

    /* Obtiene el valor del campo OrdenId */
    public function getOrdenId()
    {
        return $this->i_OrdenId;
    }

    /* Establece el valor del campo EstadoDevolucionId */
    public function setEstadoDevolucionId( $s_EstadoDevolucionId )
    {
        $this->s_EstadoDevolucionId = $s_EstadoDevolucionId;
    }

    /* Obtiene el valor del campo EstadoDevolucionId */
    public function getEstadoDevolucionId()
    {
        return $this->s_EstadoDevolucionId;
    }

    /* Establece el valor del campo Tipo */
    public function setTipo( $s_Tipo )
    {
        $this->s_Tipo = $s_Tipo;
    }

    /* Obtiene el valor del campo Tipo */
    public function getTipo()
    {
        return $this->s_Tipo;
    }

    /* Establece el valor del campo IdAlmacenOrigen */
    public function setIdAlmacenOrigen( $s_IdAlmacenOrigen )
    {
        $this->s_IdAlmacenOrigen = $s_IdAlmacenOrigen;
    }

    /* Obtiene el valor del campo IdAlmacenOrigen */
    public function getIdAlmacenOrigen()
    {
        return $this->s_IdAlmacenOrigen;
    }

    /* Establece el valor del campo IdAlmacenDestino */
    public function setIdAlmacenDestino( $s_IdAlmacenDestino )
    {
        $this->s_IdAlmacenDestino = $s_IdAlmacenDestino;
    }

    /* Obtiene el valor del campo IdAlmacenDestino */
    public function getIdAlmacenDestino()
    {
        return $this->s_IdAlmacenDestino;
    }

    /* Establece el valor del campo IdTipoDocumento */
    public function setIdTipoDocumento( $s_IdTipoDocumento )
    {
        $this->s_IdTipoDocumento = $s_IdTipoDocumento;
    }

    /* Obtiene el valor del campo IdTipoDocumento */
    public function getIdTipoDocumento()
    {
        return $this->s_IdTipoDocumento;
    }

    /* Establece el valor del campo IdNumeroDocumento */
    public function setIdNumeroDocumento( $s_IdNumeroDocumento )
    {
        $this->s_IdNumeroDocumento = $s_IdNumeroDocumento;
    }

    /* Obtiene el valor del campo IdNumeroDocumento */
    public function getIdNumeroDocumento()
    {
        return $this->s_IdNumeroDocumento;
    }

    /* Establece el valor del campo IdTransaccion */
    public function setIdTransaccion( $s_IdTransaccion )
    {
        $this->s_IdTransaccion = $s_IdTransaccion;
    }

    /* Obtiene el valor del campo IdTransaccion */
    public function getIdTransaccion()
    {
        return $this->s_IdTransaccion;
    }

    /* Establece el valor del campo TipoDocumentoFiscal */
    public function setTipoDocumentoFiscal( $s_TipoDocumentoFiscal )
    {
        $this->s_TipoDocumentoFiscal = $s_TipoDocumentoFiscal;
    }

    /* Obtiene el valor del campo TipoDocumentoFiscal */
    public function getTipoDocumentoFiscal()
    {
        return $this->s_TipoDocumentoFiscal;
    }

    /* Establece el valor del campo SerieDocumentoFiscal */
    public function setSerieDocumentoFiscal( $s_SerieDocumentoFiscal )
    {
        $this->s_SerieDocumentoFiscal = $s_SerieDocumentoFiscal;
    }

    /* Obtiene el valor del campo SerieDocumentoFiscal */
    public function getSerieDocumentoFiscal()
    {
        return $this->s_SerieDocumentoFiscal;
    }

    /* Establece el valor del campo NumeroDocumentoFiscal */
    public function setNumeroDocumentoFiscal( $s_NumeroDocumentoFiscal )
    {
        $this->s_NumeroDocumentoFiscal = $s_NumeroDocumentoFiscal;
    }

    /* Obtiene el valor del campo NumeroDocumentoFiscal */
    public function getNumeroDocumentoFiscal()
    {
        return $this->s_NumeroDocumentoFiscal;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'DevolucionTransId' => $this->getDevolucionTransId(),
            'DevolucionCabId' => $this->getDevolucionCabId(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdProyecto' => $this->getIdProyecto(),
            'OrdenId' => $this->getOrdenId(),
            'EstadoDevolucionId' => $this->getEstadoDevolucionId(),
            'Tipo' => $this->getTipo(),
            'IdAlmacenOrigen' => $this->getIdAlmacenOrigen(),
            'IdAlmacenDestino' => $this->getIdAlmacenDestino(),
            'IdTipoDocumento' => $this->getIdTipoDocumento(),
            'IdNumeroDocumento' => $this->getIdNumeroDocumento(),
            'IdTransaccion' => $this->getIdTransaccion(),
            'TipoDocumentoFiscal' => $this->getTipoDocumentoFiscal(),
            'SerieDocumentoFiscal' => $this->getSerieDocumentoFiscal(),
            'NumeroDocumentoFiscal' => $this->getNumeroDocumentoFiscal(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SR_DevolucionTransaccionBN desde un RecordSet */
    public static function retrieveByRs( $o_SR_DevolucionTransaccionRs )
    {
        $o_SR_DevolucionTransaccionBN = new SR_DevolucionTransaccionBN();
        $o_SR_DevolucionTransaccionBN->setDevolucionTransId( ( integer ) $o_SR_DevolucionTransaccionRs[ "DevolucionTransId" ] );
        $o_SR_DevolucionTransaccionBN->setDevolucionCabId( ( integer ) $o_SR_DevolucionTransaccionRs[ "DevolucionCabId" ] );
        $o_SR_DevolucionTransaccionBN->setIdCompania( ( integer ) $o_SR_DevolucionTransaccionRs[ "IdCompania" ] );
        $o_SR_DevolucionTransaccionBN->setIdSucursal( ( integer ) $o_SR_DevolucionTransaccionRs[ "IdSucursal" ] );
        $o_SR_DevolucionTransaccionBN->setIdProyecto( ( integer ) $o_SR_DevolucionTransaccionRs[ "IdProyecto" ] );
        $o_SR_DevolucionTransaccionBN->setOrdenId( ( integer ) $o_SR_DevolucionTransaccionRs[ "OrdenId" ] );
        $o_SR_DevolucionTransaccionBN->setEstadoDevolucionId( $o_SR_DevolucionTransaccionRs[ "EstadoDevolucionId" ] );
        $o_SR_DevolucionTransaccionBN->setTipo( $o_SR_DevolucionTransaccionRs[ "Tipo" ] );
        $o_SR_DevolucionTransaccionBN->setIdAlmacenOrigen( $o_SR_DevolucionTransaccionRs[ "IdAlmacenOrigen" ] );
        $o_SR_DevolucionTransaccionBN->setIdAlmacenDestino( $o_SR_DevolucionTransaccionRs[ "IdAlmacenDestino" ] );
        $o_SR_DevolucionTransaccionBN->setIdTipoDocumento( $o_SR_DevolucionTransaccionRs[ "IdTipoDocumento" ] );
        $o_SR_DevolucionTransaccionBN->setIdNumeroDocumento( $o_SR_DevolucionTransaccionRs[ "IdNumeroDocumento" ] );
        $o_SR_DevolucionTransaccionBN->setIdTransaccion( $o_SR_DevolucionTransaccionRs[ "IdTransaccion" ] );
        $o_SR_DevolucionTransaccionBN->setTipoDocumentoFiscal( $o_SR_DevolucionTransaccionRs[ "TipoDocumentoFiscal" ] );
        $o_SR_DevolucionTransaccionBN->setSerieDocumentoFiscal( $o_SR_DevolucionTransaccionRs[ "SerieDocumentoFiscal" ] );
        $o_SR_DevolucionTransaccionBN->setNumeroDocumentoFiscal( $o_SR_DevolucionTransaccionRs[ "NumeroDocumentoFiscal" ] );
        $o_SR_DevolucionTransaccionBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SR_DevolucionTransaccionRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionTransaccionBN->setUsuarioCreacion( $o_SR_DevolucionTransaccionRs[ "UsuarioCreacion" ] );
        return $o_SR_DevolucionTransaccionBN;
    }
}
?>